<template>
  <div class="info-container">
    <div class="row">
      <div class="col-xs-8">
        <div class="small-title">Описание тендера</div>
        <div class="caption">{{ tender.description }}</div>
        <div class="small-title">Контактное лицо организатора</div>
        <div class="caption">{{ tender.contacts }}</div>

        <template v-if="isRFQ">
          <div class="small-title">Период действия договора</div>
          <div class="caption">
            С {{ parseDate(tender.startContractDt) }}
            по {{ parseDate(tender.endContractDt) }}
          </div>
          <div class="small-title">Требования к подаче предложений</div>
          <div class="caption">
            Тип перевозки: {{ tender.transportationTypeTitle }}<br>
            Цены указывать в ₽ (рублях) {{ tender.vatTitle }}
          </div>
        </template>
      </div>

      <div class="col-xs-2 col-xs-offset-2">
        <TenderInfo :tender="tender" />
      </div>
    </div>

    <div class="row">
      <div class="col-xs-8">
        <div class="small-title">Инструкция</div>
        <div class="caption">
          <template v-if="tender.instruction">{{ tender.instruction }}</template>
          <span v-else class="empty-warning">Нет</span>
        </div>

        <div class="small-title">
          Дополнительные файлы к анкете
        </div>

        <div
          v-if="files.length"
          class="existing-files"
        >
          <div
            v-for="(file, i) in files"
            :key="file.uuid"
            :data-qa="'downloadFile_' + i"
            class="existing-file"
            @click="downloadFile(file)"
          >
            <span class="existing-file-text">
              {{ file.name || file.uuid }}
            </span>
          </div>
        </div>

        <span
          v-else
          class="caption empty-warning"
        >
          Нет
        </span>
      </div>
    </div>
  </div>
</template>

<script>
  import TenderInfo from './components/TenderInfo';
  import moment from 'moment';
  import api from '@/api';

  export default {
    name: "tender-tab-carrier-info",
    components: {
      TenderInfo
    },
    props: {
      tender: {
        type: Object,
        required: true
      }
    },
    computed: {
      isRFQ: ({ tender }) => tender.type === 'RFQ'
    },
    data () {
      return {
        files: []
      }
    },
    created () {
      this.files = this.tender.fileUuids.map(fileUuid => ({ uuid: fileUuid, name: '' }));

      this.getFiles();
    },
    methods: {
      getFiles () {
        if (!this.files.length) {
          return
        }

        this.files.map(async file => {
          const response = await api.files.getFile(file.uuid);

          file.name = response.name;
          file.data = response.data;
        });
      },
      downloadFile (file) {
        const fileName = file.name;
        const url = window.URL.createObjectURL(new Blob([file.data]));
        const link = document.createElement('a');

        link.href = url;
        link.setAttribute('download', fileName);

        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
      },
      parseDate (date, format = 'L') {
        return moment(date).locale('RU').format(format);
      }
    }
  };
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  @import "~common-components/src/static/css/mixins";

  .existing-files {
    display: flex;
    flex-wrap: wrap;
  }

  .existing-file {
    display: flex;
    align-items: center;
    justify-content: space-between;
    padding: 5px 12px;
    border-radius: 10px;
    background: $blue-250;
    margin: 0 10px 10px 0;
    min-height: 28px;
    cursor: pointer;
  }

  .existing-file-text {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    text-align: center;
    position: relative;
    color: $color-blue-navy-blue;
  }

  .info-container {
    padding: 30px 20px 20px;

    .row {
      flex-wrap: nowrap;
    }
  }

  .small-title {
    @include font-mixin(16px, 20px, 700, inherit, 0.4px);

    margin-bottom: 10px;
  }

  .contact {
    @include font-mixin(14px, 18px, 400, $color-blue-navy-blue);

    background: $lavender;
    border-radius: 100px;
    padding: 5px 12px;
    margin-right: 10px;
  }

  .caption {
    @include font-mixin(16px, 20px, 400);

    display: flex;
    align-items: center;
    white-space: pre-line;
    word-break: break-word; // Break too long words
    margin-bottom: 30px;
  }

  .empty-warning {
    color: $color-grey-span;
  }
</style>
